"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
Object.defineProperty(exports, "__esModule", { value: true });
var _a = (function (isWebpack) {
    if (isWebpack)
        return require('graphql');
    var resolveCwd = require('resolve-cwd');
    var graphqlPackagePath = resolveCwd.silent('graphql');
    return require(graphqlPackagePath || 'graphql');
})(typeof __non_webpack_require__ !== 'undefined'), isNonNullType = _a.isNonNullType, isListType = _a.isListType, isScalarType = _a.isScalarType, isInputType = _a.isInputType, isObjectType = _a.isObjectType, isEnumType = _a.isEnumType, GraphQLObjectType = _a.GraphQLObjectType;
var Generator_1 = require("./Generator");
var TypescriptGenerator = /** @class */ (function (_super) {
    __extends(TypescriptGenerator, _super);
    function TypescriptGenerator(_a) {
        var schema = _a.schema, inputSchemaPath = _a.inputSchemaPath, outputBindingPath = _a.outputBindingPath, isDefaultExport = _a.isDefaultExport;
        var _this = _super.call(this, { schema: schema, inputSchemaPath: inputSchemaPath, outputBindingPath: outputBindingPath, isDefaultExport: isDefaultExport }) || this;
        _this.scalarMapping = {
            Int: 'number',
            String: 'string',
            ID: 'string | number',
            Float: 'number',
            Boolean: 'boolean',
            DateTime: 'Date | string',
            Json: 'any',
        };
        _this.graphqlRenderers = {
            GraphQLUnionType: function (type) {
                return _this.renderDescription(type.description) + "export type " + type.name + " = " + type
                    .getTypes()
                    .map(function (t) { return t.name; })
                    .join(' | ');
            },
            GraphQLObjectType: function (type) {
                return (_this.renderInterfaceOrObject(type, true) +
                    '\n\n' +
                    _this.renderInterfaceOrObject(type, false));
            },
            GraphQLInterfaceType: function (type) { return _this.renderInterfaceOrObject(type); },
            GraphQLInputObjectType: function (type) {
                var fieldDefinition = Object.keys(type.getFields())
                    .map(function (f) {
                    var field = type.getFields()[f];
                    return "  " + _this.renderFieldName(field, false) + ": " + _this.renderInputFieldType(field.type);
                })
                    .join('\n');
                var interfaces = [];
                if (type instanceof GraphQLObjectType) {
                    interfaces = type.getInterfaces();
                }
                return _this.renderInterfaceWrapper(type.name, type.description, interfaces, fieldDefinition);
            },
            GraphQLScalarType: function (type) {
                if (type.name === 'ID') {
                    return _this.graphqlRenderers.GraphQLIDType(type);
                }
                return (type.description
                    ? "/*\n" + type.description + "\n*/\n"
                    : '') + "export type " + type.name + " = " + (_this.scalarMapping[type.name] || 'string');
            },
            GraphQLIDType: function (type) {
                return (type.description
                    ? "/*\n" + type.description + "\n*/\n"
                    : '') + "export type " + type.name + "_Input = " + (_this.scalarMapping[type.name] ||
                    'string') + "\nexport type " + type.name + "_Output = string";
            },
            GraphQLEnumType: function (type) {
                return _this.renderDescription(type.description) + "export type " + type.name + " = " + type
                    .getValues()
                    .map(function (e) { return "  '" + e.name + "'"; })
                    .join(' |\n');
            },
        };
        return _this;
    }
    TypescriptGenerator.prototype.render = function () {
        return this.compile(templateObject_1 || (templateObject_1 = __makeTemplateObject(["", "\n\nexport interface Query ", "\n\nexport interface Mutation ", "\n\nexport interface Subscription ", "\n\nexport interface Node {\n}\n\nexport interface Binding {\n  query: Query\n  mutation: Mutation\n  subscription: Subscription\n  request: <T = any>(query: string, variables?: {[key: string]: any}) => Promise<T>\n  delegate: Delegate\n  delegateSubscription(fieldName: string, args?: {\n      [key: string]: any;\n  }, infoOrQuery?: GraphQLResolveInfo | string, options?: Options): Promise<AsyncIterator<any>>;\n  getAbstractResolvers(filterSchema?: GraphQLSchema | string): IResolvers;\n}\n\nexport interface Delegate {\n  (\n    operation: 'query' | 'mutation',\n    fieldName: string,\n    args: {\n      [key: string]: any\n    },\n    infoOrQuery?: GraphQLResolveInfo | string,\n    options?: Options,\n  ): Promise<any>\n  query: DelegateQuery\n  mutation: DelegateMutation\n  subscription: Subscription\n}\n\nexport interface DelegateQuery ", "\n\nexport interface DelegateMutation ", "\n\nexport interface BindingConstructor<T> {\n  new(...args): T\n}\n\n", "\n\n/**\n * Types\n*/\n\n", ""], ["\\\n", "\n\nexport interface Query ", "\n\nexport interface Mutation ", "\n\nexport interface Subscription ", "\n\nexport interface Node {\n}\n\nexport interface Binding {\n  query: Query\n  mutation: Mutation\n  subscription: Subscription\n  request: <T = any>(query: string, variables?: {[key: string]: any}) => Promise<T>\n  delegate: Delegate\n  delegateSubscription(fieldName: string, args?: {\n      [key: string]: any;\n  }, infoOrQuery?: GraphQLResolveInfo | string, options?: Options): Promise<AsyncIterator<any>>;\n  getAbstractResolvers(filterSchema?: GraphQLSchema | string): IResolvers;\n}\n\nexport interface Delegate {\n  (\n    operation: 'query' | 'mutation',\n    fieldName: string,\n    args: {\n      [key: string]: any\n    },\n    infoOrQuery?: GraphQLResolveInfo | string,\n    options?: Options,\n  ): Promise<any>\n  query: DelegateQuery\n  mutation: DelegateMutation\n  subscription: Subscription\n}\n\nexport interface DelegateQuery ", "\n\nexport interface DelegateMutation ", "\n\nexport interface BindingConstructor<T> {\n  new(...args): T\n}\n\n", "\n\n/**\n * Types\n*/\n\n", ""])), this.renderImports(), this.renderQueries(), this.renderMutations(), this.renderSubscriptions(), this.renderDelegateQueries(), this.renderDelegateMutations(), this.renderExports(), this.renderTypes());
    };
    TypescriptGenerator.prototype.renderExports = function () {
        return "export const Binding = makeBindingClass<BindingConstructor<Binding>>({ schema })";
    };
    TypescriptGenerator.prototype.renderQueries = function () {
        var queryType = this.schema.getQueryType();
        if (!queryType) {
            return '{}';
        }
        return this.renderMainMethodFields('query', queryType.getFields());
    };
    TypescriptGenerator.prototype.renderMutations = function () {
        var mutationType = this.schema.getMutationType();
        if (!mutationType) {
            return '{}';
        }
        return this.renderMainMethodFields('mutation', mutationType.getFields());
    };
    TypescriptGenerator.prototype.renderDelegateQueries = function () {
        var queryType = this.schema.getQueryType();
        if (!queryType) {
            return '{}';
        }
        return this.renderMainMethodFields('query', queryType.getFields(), true);
    };
    TypescriptGenerator.prototype.renderDelegateMutations = function () {
        var mutationType = this.schema.getMutationType();
        if (!mutationType) {
            return '{}';
        }
        return this.renderMainMethodFields('mutation', mutationType.getFields(), true);
    };
    TypescriptGenerator.prototype.renderSubscriptions = function () {
        var subscriptionType = this.schema.getSubscriptionType();
        if (!subscriptionType) {
            return '{}';
        }
        return this.renderMainMethodFields('subscription', subscriptionType.getFields());
    };
    TypescriptGenerator.prototype.getTypeNames = function () {
        var ast = this.schema;
        // Create types
        return Object.keys(ast.getTypeMap())
            .filter(function (typeName) { return !typeName.startsWith('__'); })
            .filter(function (typeName) { return typeName !== ast.getQueryType().name; })
            .filter(function (typeName) {
            return ast.getMutationType()
                ? typeName !== ast.getMutationType().name
                : true;
        })
            .filter(function (typeName) {
            return ast.getSubscriptionType()
                ? typeName !== ast.getSubscriptionType().name
                : true;
        })
            .sort(function (a, b) {
            return ast.getType(a).constructor.name <
                ast.getType(b).constructor.name
                ? -1
                : 1;
        });
    };
    TypescriptGenerator.prototype.renderTypes = function () {
        var _this = this;
        var typeNames = this.getTypeNames();
        return typeNames
            .map(function (typeName) {
            var type = _this.schema.getTypeMap()[typeName];
            return _this.graphqlRenderers[type.constructor.name]
                ? _this.graphqlRenderers[type.constructor.name](type)
                : null;
        })
            .join('\n\n');
    };
    TypescriptGenerator.prototype.renderArgs = function (field, renderInfo) {
        var _this = this;
        if (renderInfo === void 0) { renderInfo = false; }
        var args = field.args;
        var hasArgs = args.length > 0;
        var allOptional = args.reduce(function (acc, curr) {
            if (!acc) {
                return false;
            }
            return !isNonNullType(curr.type);
        }, true);
        var infoString = renderInfo
            ? ', info?: GraphQLResolveInfo | string, options?: Options'
            : '';
        return "args" + (allOptional ? '?' : '') + ": {" + (hasArgs ? ' ' : '') + args
            .map(function (a) {
            return "" + _this.renderFieldName(a, false) + (isNonNullType(a.type) ? '' : '?') + ": " + _this.renderFieldType(a, false, true);
        })
            .join(', ') + (args.length > 0 ? ' ' : '') + infoString + "}";
    };
    TypescriptGenerator.prototype.renderMainMethodFields = function (operation, fields, delegate) {
        var _this = this;
        if (delegate === void 0) { delegate = false; }
        var methods = Object.keys(fields)
            .map(function (f) {
            var field = fields[f];
            return "    " + field.name + ": <T = " + _this.renderFieldType(field, true) + (!isNonNullType(field.type) ? ' | null' : '') + ">(" + _this.renderArgs(field, delegate) + ") => " + (operation === 'subscription'
                ? 'Promise<AsyncIterator<T>>'
                : _this.renderFieldType(field, delegate)) + " ";
        })
            .join(',\n');
        return "{\n" + methods + "\n  }";
    };
    TypescriptGenerator.prototype.getDeepType = function (type) {
        if (type.ofType) {
            return this.getDeepType(type.ofType);
        }
        return type;
    };
    TypescriptGenerator.prototype.getInternalTypeName = function (type) {
        var deepType = this.getDeepType(type);
        // if (isListType(type)) {
        //   return `${deepType}Array`
        // }
        var name = String(deepType);
        return name === 'ID' ? 'ID_Output' : name;
    };
    TypescriptGenerator.prototype.getPayloadType = function (operation) {
        if (operation === 'subscription') {
            return "Promise<AsyncIterator<T>>";
        }
        return "Promise<T>";
    };
    TypescriptGenerator.prototype.renderInterfaceOrObject = function (type, node) {
        var _this = this;
        if (node === void 0) { node = true; }
        var fields = type.getFields();
        var fieldDefinition = Object.keys(fields)
            .filter(function (f) {
            var deepType = _this.getDeepType(fields[f].type);
            return node ? !isObjectType(deepType) : true;
        })
            .map(function (f) {
            var field = fields[f];
            return "  " + _this.renderFieldName(field, node) + ": " + _this.renderFieldType(field, node);
        })
            .join('\n');
        var interfaces = [];
        if (type instanceof GraphQLObjectType) {
            interfaces = type.getInterfaces();
        }
        return this.renderInterfaceWrapper("" + type.name + (node ? 'Node' : ""), type.description, interfaces, fieldDefinition, !node);
    };
    TypescriptGenerator.prototype.renderFieldName = function (field, node) {
        if (!node) {
            return "" + field.name;
        }
        return "" + field.name + (isNonNullType(field.type) ? '' : '?');
    };
    TypescriptGenerator.prototype.renderFieldType = function (field, node, input) {
        if (node === void 0) { node = true; }
        if (input === void 0) { input = false; }
        var type = field.type;
        var deepType = this.getDeepType(type);
        var isList = isListType(type) || isListType(type.ofType);
        var isOptional = !(isNonNullType(type) || isNonNullType(type.ofType));
        var isScalar = isScalarType(deepType) || isEnumType(deepType);
        var isInput = isInputType(deepType) || input;
        var isObject = isObjectType(deepType);
        var typeString = this.getInternalTypeName(type);
        if (isList || node) {
            if (!isScalar && !isInput) {
                typeString += 'Node';
            }
            if (isOptional) {
                typeString += ' | undefined';
            }
        }
        if (node && (!isInput || isScalar)) {
            if (isList) {
                return "Promise<" + typeString + "[]>";
            }
            else {
                return "Promise<" + typeString + ">";
            }
        }
        if (isInput) {
            return typeString;
        }
        if (isList && isObject) {
            if (isOptional) {
                return "Promise<Array<" + typeString + ">>";
            }
            else {
                return "Promise<" + typeString + "[]>";
            }
        }
        else {
            return "(" + (field.args && field.args.length > 0 ? this.renderArgs(field) : '') + ") => " + typeString;
        }
    };
    TypescriptGenerator.prototype.renderInputFieldType = function (type) {
        if (isNonNullType(type)) {
            return this.renderInputFieldType(type.ofType);
        }
        if (isListType(type)) {
            var inputType = this.renderInputFieldType(type.ofType);
            return inputType + "[] | " + inputType;
        }
        return "" + type.name + (type.name === 'ID' ? '_Input' : '');
    };
    TypescriptGenerator.prototype.renderTypeWrapper = function (typeName, typeDescription, fieldDefinition) {
        return this.renderDescription(typeDescription) + "export type " + typeName + " = {\n" + fieldDefinition + "\n}";
    };
    TypescriptGenerator.prototype.renderInterfaceWrapper = function (typeName, typeDescription, interfaces, fieldDefinition, promise) {
        var actualInterfaces = promise
            ? [
                {
                    name: "Promise<" + typeName + "Node>",
                },
            ].concat(interfaces)
            : interfaces;
        return this.renderDescription(typeDescription) + "export interface " + typeName + (actualInterfaces.length > 0
            ? " extends " + actualInterfaces.map(function (i) { return i.name; }).join(', ')
            : '') + " {\n" + fieldDefinition + "\n}";
    };
    TypescriptGenerator.prototype.renderDescription = function (description) {
        return "" + (description
            ? "/*\n" + description.split('\n').map(function (l) { return " * " + l + "\n"; }) + "\n */\n"
            : '');
    };
    TypescriptGenerator.prototype.renderImports = function () {
        return "import { makeBindingClass, Options } from 'graphql-binding'\nimport { GraphQLResolveInfo, GraphQLSchema } from 'graphql'\nimport { IResolvers } from 'graphql-tools/dist/Interfaces'\nimport " + (this.isDefaultExport ? '' : '* as ') + "schema from  '" + this.getRelativeSchemaPath() + "'";
    };
    return TypescriptGenerator;
}(Generator_1.Generator));
exports.TypescriptGenerator = TypescriptGenerator;
var templateObject_1;
//# sourceMappingURL=TypescriptGenerator.js.map